include windows.inc
include Comctl32.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include masm32.inc
include \RadASM\Masm\Inc\RADbg.inc
include \RadASM\Masm\Inc\Debug.Inc

includelib Comctl32.lib
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib masm32.lib
includelib \RadASM\Masm\Lib\Debug.lib

HEM_RAINIT				equ WM_USER+9999	;wParam=0, lParam=pointer to controls DIALOG struct
HEM_BASE				equ WM_USER+1000
HEM_SETFONT				equ HEM_BASE+1		;wParam=nLineSpacing, lParam=lpRAFONT
HEM_GETFONT				equ HEM_BASE+2		;wParam=0, lParam=lpRAFONT
HEM_SETCOLOR			equ HEM_BASE+3		;wParam=0, lParam=lpRACOLOR
HEM_GETCOLOR			equ HEM_BASE+4		;wParam=0, lParam=lpRACOLOR

DEFBCKCOLOR				equ 00C0F0F0h
DEFTXTCOLOR				equ 00000000h
DEFSELBCKCOLOR			equ 00800000h
DEFSELTXTCOLOR			equ 00FFFFFFh
DEFCMNTCOLOR			equ 02008000h
DEFSTRCOLOR				equ 00A00000h
DEFOPRCOLOR				equ 000000A0h
DEFHILITE1				equ 00F0C0C0h
DEFHILITE2				equ 00C0F0C0h
DEFHILITE3				equ 00C0C0F0h
DEFSELBARCOLOR			equ 00C0C0C0h
DEFSELBARPEN			equ 00808080h
DEFLNRCOLOR				equ 00800000h

MAXLINEMEM				equ 32*1024
MAXCHARMEM				equ 128*1024
MAXUNDOMEM				equ 128*1024
MAXWORDMEM				equ 32*1024
MAXFREE					equ 32
MAXSTREAM				equ 32*1024

STATE_HILITEOFF			equ 0
STATE_HILITE1			equ 1
STATE_HILITE2			equ 2
STATE_HILITE3			equ 3
STATE_HILITEMASK		equ 3

STATE_BMOFF				equ 00h
STATE_BM1				equ 10h
STATE_BM2				equ 20h
STATE_BM3				equ 30h
STATE_BM4				equ 40h
STATE_BM5				equ 50h
STATE_BM6				equ 60h
STATE_BM7				equ 70h
STATE_BM8				equ 80h
STATE_BMMASK			equ 0F0h
STATE_LOCKED			equ 100h
STATE_HIDDEN			equ 200h
STATE_COMMENT			equ 400h
STATE_GARBAGE			equ 80000000h

UNDO_INSERT				equ 1
UNDO_OVERWRITE			equ 2
UNDO_DELETE				equ 3
UNDO_BACKDELETE			equ 4
UNDO_INSERTBLOCK		equ 5
UNDO_DELETEBLOCK		equ 6

STYLE_NOSPLITT			equ 001h	;No splitt button
STYLE_NOLINENUMBER		equ 002h	;No linenumber button
STYLE_NOHSCROLL			equ 008h	;No horizontal scrollbar
STYLE_NOVSCROLL			equ 010h	;No vertical scrollbar
STYLE_NOSIZEGRIP		equ 040h	;No size grip
STYLE_NODBLCLICK		equ 080h	;No action on double clicks
STYLE_READONLY			equ 100h	;Text is locked
STYLE_NOSTATE			equ 800h	;No state indicator

SBWT					equ 16
BTNWT					equ 14
BTNHT					equ 6
SELWT					equ 14
LNRWT					equ 28
SPCWT					equ 3

TIMER struct
	hwnd	dd ?
	umsg	dd ?
	lparam	dd ?
	wparam	dd ?
TIMER ends

RAFONT struct
	hFont		dd ?		;Code edit normal
	hLnrFont	dd ?		;Line numbers
RAFONT ends

RACOLOR struct
	bckcol		dd ?		;Back color
	txtcol		dd ?		;Text color
	selbckcol	dd ?		;Sel back color
	seltxtcol	dd ?		;Sel text color
	cmntcol		dd ?		;Comment color
	strcol		dd ?		;String color
	oprcol		dd ?		;Operator color
	hicol1		dd ?		;Line hilite 1
	hicol2		dd ?		;Line hilite 2
	hicol3		dd ?		;Line hilite 3
	selbarbck	dd ?		;Selection bar
	selbarpen	dd ?		;Selection bar pen
	lnrcol		dd ?		;Line numbers color
RACOLOR ends

RABRUSH struct
	hBrBck		dd ?		;Back color brush
	hBrSelBck	dd ?		;Sel back color brush
	hBrHilite1	dd ?		;Line hilite 1
	hBrHilite2	dd ?		;Line hilite 2
	hBrHilite3	dd ?		;Line hilite 3
	hBrSelBar	dd ?		;Selection bar
	hPenSelbar	dd ?		;Selection bar pen
RABRUSH ends

RAFONTINFO struct
	fntwt		dd ?		;Font width
	fntht		dd ?		;Font height
	linespace	dd ?		;Extra line spacing
RAFONTINFO ends

RAEDT struct
	hwnd		dd ?		;Handle of edit a or b
	hvscroll	dd ?		;Handle of scroll bar
	cpxmax		dd ?		;Last cursor pos x
	nline		dd ?		;Scroll position
	cp			dd ?		;Character position
	rc			RECT <?>	;Edit a or b rect
RAEDT ends

EDIT struct
	hwnd		dd ?		;Handle of main window
	fstyle		dd ?		;Window style
	ID			dd ?		;Window ID
	hpar		dd ?		;Handle of parent window
	edta		RAEDT <>
	edtb		RAEDT <>
	hhscroll	dd ?		;Handle of horizontal scrollbar
	hgrip		dd ?		;Handle of sizegrip
	hnogrip		dd ?		;Handle of nosizegrip
	hsbtn		dd ?		;Handle of splitt button
	hlin		dd ?		;Handle of linenumber button
	hsta		dd ?		;Handle of state window
	htt			dd ?		;Handle of tooltip
	fresize		dd ?		;Resize in action flag
	fsplitt		dd ?		;Splitt factor
	nsplitt		dd ?		;Splitt height

	hmem		dd ?
	nbytes		dd ?
	nsize		dd ?

	rc			RECT <?>	;Main rect
	selbarwt	dd ?		;Width of selection bar
	nlinenrwt	dd ?		;Initial width of linenumber bar
	linenrwt	dd ?		;Width of linenumber bar
	nScroll		dd ?		;Mouse wheel scroll lines
	nPageBreak	dd ?		;Page break
	cpMin		dd ?		;Selection min
	cpMax		dd ?		;Selection max
	fOvr		dd ?		;Insert / Overwrite
	cpx			dd ?		;Scroll position
	focus		dd ?		;Handle of edit having focus
	fCaretHide	dd ?		;Caret is hidden
	fChanged	dd ?		;Content changed
	fHideSel	dd ?		;Hide selection
	clr			RACOLOR <?>
	br			RABRUSH <?>
	fnt			RAFONT <?>
	fntinfo		RAFONTINFO <?>
	lpBmCB		dd ?		;Bookmark paint callback
	nchange		dd ?		;Used by EN_SELCHANGE
	nlastchange	dd ?		;Used by EN_SELCHANGE
	addrxp		dd ?
	dataxp		dd ?
	asciixp		dd ?
EDIT ends

RASELCHANGE struct
	nmhdr		NMHDR <?>
	chrg		CHARRANGE <?>
	seltyp		dw ?		;SEL_TEXT or SEL_OBJECT
	line		dd ?		;Line number
	cpLine		dd ?		;Character position of first character
	lpLine		dd ?		;Pointer to line
	nlines		dd ?		;Total number of lines
	nhidden		dd ?		;Total number of hidden lines
	fchanged	dd ?		;TRUE if changed since last
	npage		dd ?		;Page number
	nWordGroup	dd ?		;Hilite word group
RASELCHANGE ends

IDB_RAHEXEDBUTTON		equ 100
IDC_HSPLITTCUR			equ 101
IDB_BOOKMARK			equ 102
IDC_SELECTCUR			equ 103
IDB_LINENUMBER			equ 104

STYLE			equ WS_CHILD or WS_VISIBLE

;Used by RadASM 1.2.0.5
CCDEF struct
	ID			dd ?		;Controls uniqe ID
	lptooltip	dd ?		;Pointer to tooltip text
	hbmp		dd ?		;Handle of bitmap
	lpcaption	dd ?		;Pointer to default caption text
	lpname		dd ?		;Pointer to default id-name text
	lpclass		dd ?		;Pointer to class text
	style		dd ?		;Default style
	exstyle		dd ?		;Default ex-style
	flist1		dd ?		;Property listbox 1
	flist2		dd ?		;Property listbox 2
	disable		dd ?		;Disable controls child windows. 0=No, 1=Use method 1, 2=Use method 2
CCDEF ends

.data

szClassName				db 'RAHEXEDIT',0
szEditClassName			db 'RAHEXEDITCHILD',0
szToolTip				db 'RAHexEd control',0
szCap					db 'IDC_RAH',0
szName					db 'IDC_RAH',0
;Create an inited struct
ccdef					CCDEF <261,offset szToolTip,0,offset szCap,offset szName,offset szClassName,STYLE,0,11111111000110000000000000000000b,00010000000000011000000000000000b,1>
szScrollBar				db 'ScrollBar',0
szStatic				db 'Static',0
szButton				db 'Button',0
szToolTips				db 'Tooltips_class32',0

szSplitterBar			db 'Splitter Bar',0
szLineNumber			db 'Show/Hide Linenumbers',0
szExpand				db 'Expand all',0
szCollapse				db 'Collapse all',0
szChanged				db 'Changed indicator',0
szX						db 'X',0

.data?

hInstance				dd ?
hBmpLnr					dd ?
hHSCur					dd ?
hSelCur					dd ?
hIml					dd ?
OldStateProc			dd ?
OldSplittBtnProc		dd ?
TimerID					dd ?
tmr						TIMER <?>
fSize					dd ?
fSelState				dd ?
